package cn.ibizlab.humanresource.core.base.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.humanresource.core.base.domain.HRLegal;
import cn.ibizlab.humanresource.core.base.filter.HRLegalSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[HRLegal] 服务对象接口
 */
public interface IHRLegalService extends IService<HRLegal>{

    boolean create(HRLegal et) ;
    void createBatch(List<HRLegal> list) ;
    boolean update(HRLegal et) ;
    void updateBatch(List<HRLegal> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    HRLegal get(String key) ;
    HRLegal getDraft(HRLegal et) ;
    boolean checkKey(HRLegal et) ;
    boolean save(HRLegal et) ;
    void saveBatch(List<HRLegal> list) ;
    Page<HRLegal> searchDefault(HRLegalSearchContext context) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<HRLegal> getHrlegalByIds(List<String> ids) ;
    List<HRLegal> getHrlegalByEntities(List<HRLegal> entities) ;
}


